/**
 */
package emfer.reachability.util;

import emfer.reachability.*;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see emfer.reachability.ReachabilityPackage
 * @generated
 */
public class ReachabilityAdapterFactory extends AdapterFactoryImpl
{
   /**
    * The cached model package.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected static ReachabilityPackage modelPackage;

   /**
    * Creates an instance of the adapter factory.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public ReachabilityAdapterFactory()
   {
      if (modelPackage == null)
      {
         modelPackage = ReachabilityPackage.eINSTANCE;
      }
   }

   /**
    * Returns whether this factory is applicable for the type of the object.
    * <!-- begin-user-doc -->
    * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
    * <!-- end-user-doc -->
    * @return whether this factory is applicable for the type of the object.
    * @generated
    */
   @Override
   public boolean isFactoryForType(Object object)
   {
      if (object == modelPackage)
      {
         return true;
      }
      if (object instanceof EObject)
      {
         return ((EObject)object).eClass().getEPackage() == modelPackage;
      }
      return false;
   }

   /**
    * The switch that delegates to the <code>createXXX</code> methods.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected ReachabilitySwitch<Adapter> modelSwitch =
      new ReachabilitySwitch<Adapter>()
      {
         @Override
         public Adapter caseReachabilityGraph(ReachabilityGraph object)
         {
            return createReachabilityGraphAdapter();
         }
         @Override
         public Adapter caseGameState(GameState object)
         {
            return createGameStateAdapter();
         }
         @Override
         public Adapter caseReachableState(ReachableState object)
         {
            return createReachableStateAdapter();
         }
         @Override
         public Adapter caseOperationName(OperationName object)
         {
            return createOperationNameAdapter();
         }
         @Override
         public Adapter caseTrafoApplication(TrafoApplication object)
         {
            return createTrafoApplicationAdapter();
         }
         @Override
         public Adapter defaultCase(EObject object)
         {
            return createEObjectAdapter();
         }
      };

   /**
    * Creates an adapter for the <code>target</code>.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @param target the object to adapt.
    * @return the adapter for the <code>target</code>.
    * @generated
    */
   @Override
   public Adapter createAdapter(Notifier target)
   {
      return modelSwitch.doSwitch((EObject)target);
   }


   /**
    * Creates a new adapter for an object of class '{@link emfer.reachability.ReachabilityGraph <em>Graph</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see emfer.reachability.ReachabilityGraph
    * @generated
    */
   public Adapter createReachabilityGraphAdapter()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link emfer.reachability.GameState <em>Game State</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see emfer.reachability.GameState
    * @generated
    */
   public Adapter createGameStateAdapter()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link emfer.reachability.ReachableState <em>Reachable State</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see emfer.reachability.ReachableState
    * @generated
    */
   public Adapter createReachableStateAdapter()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link emfer.reachability.OperationName <em>Operation Name</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see emfer.reachability.OperationName
    * @generated
    */
   public Adapter createOperationNameAdapter()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link emfer.reachability.TrafoApplication <em>Trafo Application</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see emfer.reachability.TrafoApplication
    * @generated
    */
   public Adapter createTrafoApplicationAdapter()
   {
      return null;
   }

   /**
    * Creates a new adapter for the default case.
    * <!-- begin-user-doc -->
    * This default implementation returns null.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @generated
    */
   public Adapter createEObjectAdapter()
   {
      return null;
   }

} //ReachabilityAdapterFactory
